Index: esolan.f
===================================================================
--- esolan.f	(revision 87ddcf7a314d90070d607f0ec7ac0a700b843abc)
+++ esolan.f	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
@@ -1,100 +1,71 @@
-! **************************************************************
-!
-! This file contains the subroutines: esolan
-!
-! Copyright 2003-2005  Frank Eisenmenger, U.H.E. Hansmann,
-!                      Shura Hayryan, Chin-Ku
-! Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
-!                      Jan H. Meinke, Sandipan Mohanty
-!
-! **************************************************************
+c **************************************************************
+c
+c This file contains the subroutines: esolan
+c
+c Copyright 2003-2005  Frank Eisenmenger, U.H.E. Hansmann,
+c                      Shura Hayryan, Chin-Ku 
+c Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
+c                      Jan H. Meinke, Sandipan Mohanty
+c
+c **************************************************************
 
       real*8 function esolan(nmol)
 
-! -----------------------------------------------------------------
-!
-! Calculates the solvation energy of the protein with
-! solavtion parameters model E=\sum\sigma_iA_i.
-! The solvent accessible surface area per atom
-! and its gradients with respect to the Cartesian coordinates of
-! the atoms are calculated using the projection method described in
-!
-!            J Comp Phys 26, 334-343, 2005
-!
-! USAGE: eysl=esolan(nmol)-Returns the value of the solvation energy
-!
-! INPUT: nmol - the order number of the protein chain.
-!      The atomic coordinates, radii and solvation parameters
-!      are taken from the global arrays of SMMP
-!
-! OUTPUT: global array gradan(mxat,3) contains the gradients of
-!         solvation energy per atom
-!         local array as(mxat) contains accessible surface area per atom
-!
-! Output file "solvation.dat' conatains detailed data.
-!
-! Correctness of this program was last time rechecked with GETAREA
-!
-! CALLS: none
-!
-! ----------------------------------------------------------------------
-! TODO Test the solvent energy for multiple molecules
+c -----------------------------------------------------------------
+c
+c Calculates the solvation energy of the protein with 
+c solavtion parameters model E=\sum\sigma_iA_i. 
+c The solvent accessible surface area per atom
+c and its gradients with respect to the Cartesian coordinates of 
+c the atoms are calculated using the projection method described in
+c
+c            J Comp Phys 26, 334-343, 2005
+c
+C USAGE: eysl=esolan(nmol)-Returns the value of the solvation energy
+c
+c INPUT: nmol - the order number of the protein chain.
+c      The atomic coordinates, radii and solvation parameters  
+c      are taken from the global arrays of SMMP
+c
+c OUTPUT: global array gradan(mxat,3) contains the gradients of 
+c         solvation energy per atom
+c         local array as(mxat) contains accessible surface area per atom
+c
+c Output file "solvation.dat' conatains detailed data.
+c
+c Correctness of this program was last time rechecked with GETAREA
+c
+c CALLS: none
+c
+c ----------------------------------------------------------------------
+c TODO Test the solvent energy for multiple molecules
 
       include 'INCL.H'
-
-
-      integer nmol, ks0, ks2
-Cf2py intent(in) nmol
-
+      
+      
       parameter (ks0=mxat*(mxat+1))
       parameter (ks2=mxat+mxat)
-! Functions
-      real*8 grnd
-
-      integer neib, neibp, ivrx, iv, ial, i, ij, j, iii, idi,ivr, ifu,
-     &          ita2, ita3, ine, kk, j2, jkk, jjj, jj, jk, k, l, ll,
-     &          nb, numat, nyx
-      real*8 vertex, ax, pol, as, ayx, ayx1, probe, dd, ddat, dadx, gp,
-     &          dalp,dbet, daalp, dabet, vrx, dv, dx, dy, dz, dt, di,
-     &          dii, ss, dta, dtb, di1, di2, gs, xold, yold, zold,
-     &          energy, sss, a1, a, ab1, a2, aa, ac2, ac1, ab2, am2,
-     &          am, aia, ak, alp, am1, ap1, amibe, amabe, amaal, amial,
-     &          ang, D, ddp, cf, b2, arg2, arg1, ap2, b, b1, b2c2, ca,
-     &          ba, bcd, bc, bet, c1, c, c2, cc, sfcg, caba, cg, cfsg,
-     &          cfcg, daba, ct, cs, d1, d2, dbe, dal, dcotbma, dcbet,
-     &          dcalp, dcbetmalp, dcbetpalp, ddp2, div, dsbetmalp,
-     &          dsalp, dsbet, yy, dsbetpalp, enr, p1, p2, r42, r22,
-     &          r22p, r2, pom, prob, r, r42p, ratom, rr, s, sfsg, sf,
-     &          sg, vv1, t, ufi, tt, uga, uv, vv, vv2, wv, xx, xv, yv,
-     &          zz, zv
-      dimension neib(0:mxat),neibp(0:mxat),ivrx(ks0)
-      dimension vertex(ks0,4),ax(ks0,2),
-     &          pol(mxat),as(mxat),ayx(ks0,2),
-     &          ayx1(ks0),probe(ks0),dd(mxat),ddat(mxat,4)
-      dimension dadx(4,3),gp(4),dalp(4),dbet(4),
-     &   daalp(4),dabet(4),vrx(ks0,4),dv(4),dx(4),dy(4),dz(4),dt(4),
-     &   di(4),dii(4,3),ss(mxat),dta(4),dtb(4),di1(4),di2(4),gs(3)
+      
+      dimension neib(0:mxat),vertex(ks0,4),ax(ks0,2),
+     1          pol(mxat),neibp(0:mxat),as(mxat),ayx(ks0,2),
+     2          ayx1(ks0),probe(ks0),dd(mxat),ddat(mxat,4),ivrx(ks0)
+       
+      dimension grad(mxat,mxat,3),dadx(4,3),gp(4),dalp(4),dbet(4),
+     1   daalp(4),dabet(4),vrx(ks0,4),dv(4),dx(4),dy(4),dz(4),dt(4),
+     2   di(4),dii(4,3),ss(mxat),dta(4),dtb(4),di1(4),di2(4),gs(3)
       dimension xold(-1:mxat),yold(-1:mxat),zold(-1:mxat)
       integer ta2(0:mxat),ta3(0:mxat),fullarc(0:mxat),al(0:ks2)
       real*8 neibor(mxat,4)
-
-      real*8, dimension(:, :, :), allocatable :: grad
-
-      allocate(grad(mxat, mxat, 3))
-
-
-!     open(3,file='solvation.dat')! Output file with solvation data
+      
+      
+c     open(3,file='solvation.dat')! Output file with solvation data
 
       energy=0.0d0 ! Total solvation energy
       sss=0.0d0 ! Total solvent accessible surface area
-      if (nmol.eq.0) then
-         numat=iatrs2(irsml2(ntlml))-iatrs1(irsml1(1))+1 ! Number of atoms
-      else
-         numat=iatrs2(irsml2(nmol))-iatrs1(irsml1(nmol))+1 ! Number of atoms
-      endif
+      numat=iatrs2(irsml2(nmol))-iatrs1(irsml1(nmol))+1 ! Number of atoms
 
       do i=1,numat
         do j=1,3
-         gradan(i,j)=0.0d0
+         gradan(i,j)=0.0d0 
       end do
       end do
@@ -102,10 +73,10 @@
       do i=1,numat
          xold(i)=xat(i)! Redefine the coordinates just for safety
-         yold(i)=yat(i)!
-         zold(i)=zat(i)!
-      pol(i)=rvdw(i)*rvdw(i)!The water radius is already added in 'main'
+         yold(i)=yat(i)! 
+         zold(i)=zat(i)! 
+      pol(i)=rvdw(i)*rvdw(i)!The water radius is already added in 'main' 
       As(i)=pi4*pol(i)! Initially the whole surface of the atom is accessible.
       end do
-
+      
              do iii=1,numat
               do jjj=1,numat
@@ -116,22 +87,21 @@
              enddo
 
-!***************************
-!   Start the computations *
-!***************************
-
-      do 1 i=1,numat ! Lop over atoms "i"
-! ----------------------------------------------------
-
-       R=rvdw(i)
+c***************************
+c   Start the computations *
+c***************************
+
+      do 1 i=1,numat ! Lop over atoms "i"           
+c ----------------------------------------------------
+         
+       R=rvdw(i) 
        jj=0
         do j=1,numat !Find the neighbours of "i"
        if(i.ne.j) then
        ddp=(xold(j)-xold(i))**2+(yold(j)-yold(i))**2
-     &   +(zold(j)-zold(i))**2! Distance between atom i and j
+     #   +(zold(j)-zold(i))**2! Distance between atom i and j
        if(ddp.lt.1e-10) then
-         write (logString, *)
-     &      'ERROR in data: centres of two atoms coincide!'
-         write (logString, *)i,j,xold(i),yold(i),zold(i),rvdw(i),
-     &                   xold(j),yold(j),zold(j),rvdw(j)
+         write(*,*)'ERROR in data: centres of two atoms coincide!'
+         write(*,*)i,j,xold(i),yold(i),zold(i),rvdw(i),
+     #                   xold(j),yold(j),zold(j),rvdw(j) 
          stop 'Centres of atoms coincide!'
        endif
@@ -147,10 +117,10 @@
          end if
          end do!Neighbours
-
+       
        neib(0)=jj   ! The number of neighbors of "i"
 
        if(neib(0).eq.0) goto 1 !Finish the atom i if it doesn't have neighbors
 
-!----
+c----
        R2=R*R                   ! R square
        R22=R2+R2             ! 2 * R square
@@ -170,33 +140,33 @@
            ddat(i,4)=0d0
            ddat(i,1)=R
-!
-!    Verification of the north point of ith sphere
-!
+c
+c    Verification of the north point of ith sphere
+c
        jjj=0
-!
-!      If jjj=0 then - no transformation
-!             else the transformation is necessary
-!
+c
+c      If jjj=0 then - no transformation
+c             else the transformation is necessary
+c
        k=neib(1)  ! The order number of the first neighbour
-! ddp - the square minimal distance of NP from the neighboring surfaces
+c ddp - the square minimal distance of NP from the neighboring surfaces
        ddp=dabs((ddat(k,2))**2+(ddat(k,3))**2+
-     &    (R-ddat(k,4))**2-pol(k))
+     #    (R-ddat(k,4))**2-pol(k))
 
        do j=2,neib(0)
         k=neib(j)
         ddp2=dabs((ddat(k,2))**2+(ddat(k,3))**2+
-     &      (R-ddat(k,4))**2-pol(k))
+     #      (R-ddat(k,4))**2-pol(k))
         if(ddp2.lt.ddp) ddp=ddp2
        enddo
-!
-!   Check whether the NP of ith sphere is too close to the intersection line
-!
+c
+c   Check whether the NP of ith sphere is too close to the intersection line
+c
        do while (ddp.lt.1.d-6)
         jjj=jjj+1
-!
-!       generate grndom numbers
-!
+c
+c       generate grndom numbers
+c
         uga=grnd() ! Random \gamma angle
-        ufi=grnd() ! Random \pi angle
+        ufi=grnd() ! Random \pi angle 
         uga=pi*uga/2
         ufi=pi*ufi/2
@@ -212,14 +182,14 @@
         k=neib(1)
         ddp=dabs((xx-ddat(k,2))**2+(yy-ddat(k,3))**2+
-     &     (zz-ddat(k,4))**2-pol(k))
+     #     (zz-ddat(k,4))**2-pol(k))
         do j=2,neib(0)
          k=neib(j)
          ddp2=dabs((xx-ddat(k,2))**2+(yy-ddat(k,3))**2+
-     &       (zz-ddat(k,4))**2-pol(k))
+     #       (zz-ddat(k,4))**2-pol(k))
          if(ddp2.lt.ddp) ddp=ddp2
         end do
       end do
-!
-
+c       
+      
        if(jjj.ne.0) then ! Rotation is necessary
          sfsg=sf*sg
@@ -236,21 +206,21 @@
        endif
 
-!  iiiiiiiiiii
+c  iiiiiiiiiii
 
        pom=8.d0*pol(i)
 
-! In this loop the parameters a,b,c,d for the equation
-!      a*(t^2+s^2)+b*t+c*s+d=0 are calculated (see the reference article)
+C In this loop the parameters a,b,c,d for the equation
+c      a*(t^2+s^2)+b*t+c*s+d=0 are calculated (see the reference article)
       do jj=1,neib(0)
       j=neib(jj)
-       neibor(j,1)=(ddat(j,2))**2+(ddat(j,3))**2+
-     &            (ddat(j,4)-R)**2-pol(j)           ! a
+       neibor(j,1)=(ddat(j,2))**2+(ddat(j,3))**2+      
+     #            (ddat(j,4)-R)**2-pol(j)           ! a
         neibor(j,2)=-pom*ddat(j,2)                  ! b
         neibor(j,3)=-pom*ddat(j,3)                  ! c
         neibor(j,4)=4d0*pol(i)*((ddat(j,2))**2+
-     &      (ddat(j,3))**2+(R+ddat(j,4))**2-pol(j)) ! d
+     #      (ddat(j,3))**2+(R+ddat(j,4))**2-pol(j)) ! d
        enddo
 
-!       end of the 1st cleaning
+c       end of the 1st cleaning
 
        iv=0
@@ -260,5 +230,5 @@
        do while(k.gt.1)               ! B
         k=k-1
-! Analyse mutual disposition of every pair of neighbours
+C Analyse mutual disposition of every pair of neighbours                                                      
         do 13 L=neib(0),k+1,-1        ! A
 
@@ -272,9 +242,9 @@
           d2=neibor(neib(L),4)/neibor(neib(L),1)
           D=4d0*((b1-b2)*(b2*d1-b1*d2)+(c1-c2)*(c2*d1-c1*d2)-
-     &      (d1-d2)**2)+(b1*c2-b2*c1)**2
-! if D<0 then the circles neib(k) and neib(L) don't intersect
+     #      (d1-d2)**2)+(b1*c2-b2*c1)**2
+C if D<0 then the circles neib(k) and neib(L) don't intersect
           if(D.le.0d0.and.dsqrt((b1-b2)**2+(c1-c2)**2).le.      ! a01 01
-     &     dsqrt(b2*b2+c2*c2-4d0*d2)-dsqrt(b1*b1+c1*c1-4d0*d1)) then ! 04
-! Circle neib(L) encloses circle neib(k) and the later is discarded
+     #     dsqrt(b2*b2+c2*c2-4d0*d2)-dsqrt(b1*b1+c1*c1-4d0*d1)) then ! 04
+C Circle neib(L) encloses circle neib(k) and the later is discarded
            neib(0)=neib(0)-1
            do j=k,neib(0)
@@ -283,6 +253,6 @@
            goto 12
           elseif(D.le.0d0.and.dsqrt((b1-b2)**2+(c1-c2)**2).le.      ! a01 02
-     &    -dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then
-! The circle neib(k) encloses circle neib(L) and the later is discarded
+     #    -dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then
+C The circle neib(k) encloses circle neib(L) and the later is discarded 
            neib(0)=neib(0)-1
            do j=L,neib(0)
@@ -290,5 +260,5 @@
            enddo
           elseif(D.gt.0d0) then                        ! a01 03
-! The circles nieb(L) and neib(k) have two intersection points (IP)
+C The circles nieb(L) and neib(k) have two intersection points (IP)
            am=2d0*((b1-b2)**2+(c1-c2)**2)
            t=-2d0*(b1-b2)*(d1-d2)-(b2*c1-b1*c2)*(c1-c2)
@@ -310,5 +280,5 @@
 
          elseif(neibor(neib(k),1).gt.0d0.and.      ! a03
-     &              neibor(neib(L),1).lt.0d0) then
+     #              neibor(neib(L),1).lt.0d0) then
           b1=neibor(neib(k),2)/neibor(neib(k),1)
           c1=neibor(neib(k),3)/neibor(neib(k),1)
@@ -318,14 +288,14 @@
           d2=neibor(neib(L),4)/neibor(neib(L),1)
           D=4d0*((b1-b2)*(b2*d1-b1*d2)+(c1-c2)*(c2*d1-c1*d2)-
-     &        (d1-d2)**2)+(b1*c2-b2*c1)**2
-! if D<0 then neib(k) and neib(L) don't intersect
+     #        (d1-d2)**2)+(b1*c2-b2*c1)**2
+C if D<0 then neib(k) and neib(L) don't intersect
           if(D.le.0d0.and.dsqrt((b1-b2)**2+(c1-c2)**2).le.  ! a03 01
-     &     -dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then ! 06
-! Neighbours neib(k) and neib(L) cover fully the atom "i" and as(i)=0
+     #     -dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then ! 06
+C Neighbours neib(k) and neib(L) cover fully the atom "i" and as(i)=0
            As(i)=0.d0
            goto 11
           elseif(D.le.0d0.and.dsqrt((b1-b2)**2+(c1-c2)**2).ge.  ! a03 02
-     &      dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then
-! Don't exclude neib(k)
+     #      dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then
+C Don't exclude neib(k) 
            neib(0)=neib(0)-1
            do j=k,neib(0)
@@ -334,5 +304,5 @@
            goto 12
           elseif(D.gt.0.d0) then                        ! a03 03
-! Circles neib(L) and neib(k) have two intersection points.
+C Circles neib(L) and neib(k) have two intersection points.
            am=2d0*((b1-b2)**2+(c1-c2)**2)
            t=-2d0*(b1-b2)*(d1-d2)-(b2*c1-b1*c2)*(c1-c2)
@@ -354,5 +324,5 @@
 
          elseif(neibor(neib(k),1).lt.0d0.and.neibor(neib(L),1).gt.0d0)! a07
-     &           then
+     #           then
           b1=neibor(neib(k),2)/neibor(neib(k),1)
           c1=neibor(neib(k),3)/neibor(neib(k),1)
@@ -362,14 +332,14 @@
           d2=neibor(neib(L),4)/neibor(neib(L),1)
           D=4d0*((b1-b2)*(b2*d1-b1*d2)+(c1-c2)*(c2*d1-c1*d2)-
-     &        (d1-d2)**2)+(b1*c2-b2*c1)**2
-! If D<0 then the circles neib(k) and neib(L) don't intersect
+     #        (d1-d2)**2)+(b1*c2-b2*c1)**2
+C If D<0 then the circles neib(k) and neib(L) don't intersect
           if(D.le.0d0.and.dsqrt((b1-b2)**2+(c1-c2)**2).le.   ! a07 01
-     &     dsqrt(b2*b2+c2*c2-4d0*d2)-dsqrt(b1*b1+c1*c1-4d0*d1)) then    ! 10
-! atom "i" is covered fully by neib(k) and neib(L) and as(i)=0.
+     #     dsqrt(b2*b2+c2*c2-4d0*d2)-dsqrt(b1*b1+c1*c1-4d0*d1)) then    ! 10
+C atom "i" is covered fully by neib(k) and neib(L) and as(i)=0.
            As(i)=0.d0
            goto 12
           elseif(D.le.0d0.and.dsqrt((b1-b2)**2+(c1-c2)**2).ge.   ! a07 02
-     &      dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then
-! discard the circle neib(L)
+     #      dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then
+C discard the circle neib(L) 
            neib(0)=neib(0)-1
            do j=L,neib(0)
@@ -377,5 +347,5 @@
            enddo
           elseif(D.gt.0d0) then                          ! a07 03
-! There are two IP's between neib(k) and neib(L).
+C There are two IP's between neib(k) and neib(L).
            am=2d0*((b1-b2)**2+(c1-c2)**2)
            t=-2d0*(b1-b2)*(d1-d2)-(b2*c1-b1*c2)*(c1-c2)
@@ -385,6 +355,6 @@
            p1=(c1-c2)*pom
            p2=(b1-b2)*pom
-!-- Assign t and s coordinates and the order number of circles
-           vertex(iv,1)=(t+p1)/am
+c-- Assign t and s coordinates and the order number of circles
+           vertex(iv,1)=(t+p1)/am 
            vertex(iv,2)=(s-p2)/am
            vertex(iv,3)=neib(k)
@@ -395,9 +365,9 @@
            vertex(iv,3)=neib(k)
            vertex(iv,4)=neib(L)
-!--
+c--  
           endif                                                 ! 10
 
          elseif(neibor(neib(k),1).lt.0d0.and.neibor(neib(L),1).lt.0d0) ! a09
-     &           then
+     #           then
           b1=neibor(neib(k),2)/neibor(neib(k),1)
           c1=neibor(neib(k),3)/neibor(neib(k),1)
@@ -407,9 +377,9 @@
           d2=neibor(neib(L),4)/neibor(neib(L),1)
           D=4d0*((b1-b2)*(b2*d1-b1*d2)+(c1-c2)*(c2*d1-c1*d2)-
-     &        (d1-d2)**2)+(b1*c2-b2*c1)**2
-! D<0 - no intersection poit between neib(k) and neib(L)
+     #        (d1-d2)**2)+(b1*c2-b2*c1)**2
+C D<0 - no intersection poit between neib(k) and neib(L)
           if(D.le.0d0.and.dsqrt((b1-b2)**2+(c1-c2)**2).le.
-     &   dsqrt(b2*b2+c2*c2-4d0*d2)-dsqrt(b1*b1+c1*c1-4d0*d1)) then!12 ! a09 01
-! omit the circle neib(L)
+     #   dsqrt(b2*b2+c2*c2-4d0*d2)-dsqrt(b1*b1+c1*c1-4d0*d1)) then!12 ! a09 01
+C omit the circle neib(L)
            neib(0)=neib(0)-1
            do j=L,neib(0)
@@ -417,6 +387,6 @@
            enddo
           elseif(D.le.0d0.and.dsqrt((b1-b2)**2+(c1-c2)**2).le. ! a09 02
-     &     -dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then
-! Omit the circle neib(k)
+     #     -dsqrt(b2*b2+c2*c2-4d0*d2)+dsqrt(b1*b1+c1*c1-4d0*d1)) then
+C Omit the circle neib(k)
            neib(0)=neib(0)-1
            do j=k,neib(0)
@@ -425,9 +395,9 @@
            goto 12
           elseif(D.le.0.d0) then                            ! a09 03
-! The whole surface of atom "i" is covered fully, and as(i)=0.
+C The whole surface of atom "i" is covered fully, and as(i)=0.
            As(i)=0.d0
            goto 11
           else                                             ! a09 04
-! Two intersection points
+C Two intersection points
            am=2.d0*((b1-b2)**2+(c1-c2)**2)
            t=-2.d0*(b1-b2)*(d1-d2)-(b2*c1-b1*c2)*(c1-c2)
@@ -437,5 +407,5 @@
            p1=(c1-c2)*pom
            p2=(b1-b2)*pom
-! Assign the t and s coordinates and order numbers of the circles
+C Assign the t and s coordinates and order numbers of the circles
            vertex(iv,1)=(t+p1)/am
            vertex(iv,2)=(s-p2)/am
@@ -458,10 +428,10 @@
         do j=1,neib(0)
         if(neibor(neib(j),1).eq.0.d0) then
-! Collect the lines (after rotation it is empty).
+C Collect the lines (after rotation it is empty).
          ita2=ita2+1
          ta2(ita2)=j
         endif
         if(neibor(neib(j),1).lt.0.d0) then
-! Collect the neighbours with inner part
+C Collect the neighbours with inner part
          ita3=ita3+1
          ta3(ita3)=j
@@ -469,5 +439,5 @@
        enddo
 
-!*** Consider to remove this part.
+c*** Consider to remove this part.
          if(ita2.gt.0.and.ita3.lt.1) then
            As(i)=R22p
@@ -492,5 +462,5 @@
             dbe=amabe-amibe
             if(dal.lt.pi) then
-             As(i)=R22*(pi-dal)
+             As(i)=R22*(pi-dal)  
             elseif(dbe.lt.pi) then
              As(i)=R22*(pi-dbe)
@@ -502,5 +472,5 @@
           As(i)=0d0
          endif
-!****** End of could-be-removed part
+c****** End of could-be-removed part
 
        neibp(0)=neib(0)
@@ -511,10 +481,10 @@
        enddo
        do j=1,neib(0)
-! "iv" is the number of intersection point.
+C "iv" is the number of intersection point. 
         do k=1,iv
        if(neibp(j).eq.vertex(k,3).or.neibp(j).eq.vertex(k,4)) goto 30
         enddo
          ifu=ifu+1
-! Arrays with the ordering numbers of full arcs.
+C Arrays with the ordering numbers of full arcs.
          fullarc(ifu)=neibp(j)
          al(ifu)=neibp(j)
@@ -530,8 +500,8 @@
        al(0)=ifu
 
-! Loop over full arcs.
+C Loop over full arcs.
        do k=1,ifu
          a=neibor(fullarc(k),1)
-         if(a.lt.0.d0) then
+         if(a.lt.0.d0) then 
           aia=-1.d0
          else
@@ -542,7 +512,7 @@
          d=neibor(fullarc(k),4)
          if(a.ne.0d0) then !True if rotation has taken place.
-! Remove the part of the atomic surface covered cut by this full arc
+C Remove the part of the atomic surface covered cut by this full arc
           As(i)=As(i)-aia*R22p*(1d0+(-d/a-R42)*dabs(a)/dsqrt((R42*a-
-     &                 d)**2+R42*(b*b+c*c)))
+     #                 d)**2+R42*(b*b+c*c)))
           dadx(1,1)=2d0*ddat(fullarc(k),2)
           dadx(1,2)=2d0*ddat(fullarc(k),3)
@@ -563,9 +533,9 @@
           gp(4)=(b*b+c*c-2d0*a*d+(R42+R42)*a*a)*div
           grad(i,fullarc(k),1)=gp(1)*dadx(1,1)+gp(2)*dadx(2,1)+
-     &        gp(3)*dadx(3,1)+gp(4)*dadx(4,1)
+     #        gp(3)*dadx(3,1)+gp(4)*dadx(4,1)
           grad(i,fullarc(k),2)=gp(1)*dadx(1,2)+gp(2)*dadx(2,2)+
-     &        gp(3)*dadx(3,2)+gp(4)*dadx(4,2)
+     #        gp(3)*dadx(3,2)+gp(4)*dadx(4,2)
           grad(i,fullarc(k),3)=gp(1)*dadx(1,3)+gp(2)*dadx(2,3)+
-     &        gp(3)*dadx(3,3)+gp(4)*dadx(4,3)
+     #        gp(3)*dadx(3,3)+gp(4)*dadx(4,3)
 
          else
@@ -574,5 +544,5 @@
        enddo
 
-! Loop over the circles with intersection points.
+c Loop over the circles with intersection points.
        do k=1,ine
          jk=neib(k) ! The order number of kth neighbour.
@@ -580,5 +550,5 @@
          ak=a*a
          daba=dabs(a)
-         if(a.lt.0d0) then
+         if(a.lt.0d0) then 
           aia=-1d0
           else
@@ -632,6 +602,6 @@
              yv=(bcd+2d0*R42*ak)/daba*vv1
              zv=wv/a*vv1
-! Move the (t,s) origo into the centre of this circle.
-! Modify t and s coordinates of IP.
+C Move the (t,s) origo into the centre of this circle.
+C Modify t and s coordinates of IP.
           do j=1,nyx
            ayx(j,1)=ayx(j,1)+ba ! t
@@ -642,9 +612,9 @@
           cs=-ca
           rr=0.5d0*wv/daba
-! Calculate the polar angle of IP.
+C Calculate the polar angle of IP.
           do j=1,nyx
            ayx1(j)=datan2(ayx(j,2),ayx(j,1))
           enddo
-! Sort the angles in ascending order.
+C Sort the angles in ascending order.
           do j=1,nyx-1
            a1=ayx1(j)
@@ -680,6 +650,6 @@
           do j=1,nyx
 
-!
-!  Escape 'bad' intersections.
+c  
+c  Escape 'bad' intersections.
            if(dabs(ayx1(j+1)-ayx1(j)).lt.1d-8) goto 40
 
@@ -687,9 +657,9 @@
            ap1=ct+rr*dcos(prob) ! The middle point of the arc.
            ap2=cs+rr*dsin(prob)
-! Verify if the middle point belongs to a covered part.
-! If yes then omit.
+C Verify if the middle point belongs to a covered part. 
+C If yes then omit.
            do ij=1,ial
           if(neibor(al(ij),1)*(ap1*ap1+ap2*ap2)+neibor(al(ij),2)*ap1+
-     &         neibor(al(ij),3)*ap2+neibor(al(ij),4).lt.0d0) goto 40
+     #         neibor(al(ij),3)*ap2+neibor(al(ij),4).lt.0d0) goto 40
            enddo
              alp=ayx1(j)
@@ -705,7 +675,7 @@
              dcotbma=1.d0/dtan(5d-1*(bet-alp))
              uv=daba*(bcd+2d0*R42*ak)*dcbetmalp
-     &          -a*dsqrt(b2c2-4d0*a*d)*(b*dcbetpalp+c*dsbetpalp)
+     #          -a*dsqrt(b2c2-4d0*a*d)*(b*dcbetpalp+c*dsbetpalp)
              As(i)=As(i)+R2*(aia*(alp-bet)+(d+R42*a)*vv1*(pi-2d0*
-     &             datan(uv/(2d0*ak*vv*dsbetmalp))))
+     #             datan(uv/(2d0*ak*vv*dsbetmalp))))
              kk=vrx(j,4)
              LL=vrx(j+1,4)
@@ -726,49 +696,49 @@
              am2=wv*aia*a2*(ab2*dsbet-ac2*dcbet)
              dalp(1)=(b1*ab1+c1*ac1-2d0*d*a1*a1-a*
-     &               (b1*b1+c1*c1-4d0*a1*d1)-2d0*d*aia*a1*(ab1*
-     &               dcalp+ac1*dsalp)/wv+wv*aia*a1*
-     &               (b1*dcalp+c1*dsalp))/am1
+     1               (b1*b1+c1*c1-4d0*a1*d1)-2d0*d*aia*a1*(ab1*
+     2               dcalp+ac1*dsalp)/wv+wv*aia*a1*
+     3               (b1*dcalp+c1*dsalp))/am1
              dalp(2)=(-a1*ab1+b*a1*a1+b*aia*a1*(ab1*
-     &               dcalp+ac1*dsalp)/wv-wv*aia*a1*a1*dcalp)/am1
+     1               dcalp+ac1*dsalp)/wv-wv*aia*a1*a1*dcalp)/am1
              dalp(3)=(-a1*ac1+c*a1*a1+c*aia*a1*(ab1*
-     &               dcalp+ac1*dsalp)/wv-wv*aia*a1*a1*dsalp)/am1
+     #               dcalp+ac1*dsalp)/wv-wv*aia*a1*a1*dsalp)/am1
              dalp(4)=(-2d0*a*a1*a1-2d0*daba*a1*(ab1*
-     &               dcalp+ac1*dsalp)/wv)/am1
+     #               dcalp+ac1*dsalp)/wv)/am1
              dbet(1)=(b2*ab2+c2*ac2-2d0*d*a2*a2-a*
-     &               (b2*b2+c2*c2-4d0*a2*d2)-2d0*d*aia*a2*(ab2*
-     &               dcbet+ac2*dsbet)/wv+wv*aia*a2*
-     &               (b2*dcbet+c2*dsbet))/am2
+     #               (b2*b2+c2*c2-4d0*a2*d2)-2d0*d*aia*a2*(ab2*
+     #               dcbet+ac2*dsbet)/wv+wv*aia*a2*
+     #               (b2*dcbet+c2*dsbet))/am2
              dbet(2)=(-a2*ab2+b*a2*a2+b*aia*a2*(ab2*
-     &               dcbet+ac2*dsbet)/wv-wv*aia*a2*a2*dcbet)/am2
+     #               dcbet+ac2*dsbet)/wv-wv*aia*a2*a2*dcbet)/am2
              dbet(3)=(-a2*ac2+c*a2*a2+c*aia*a2*(ab2*
-     &               dcbet+ac2*dsbet)/wv-wv*aia*a2*a2*dsbet)/am2
+     #               dcbet+ac2*dsbet)/wv-wv*aia*a2*a2*dsbet)/am2
              dbet(4)=(-2d0*a*a2*a2-2d0*daba*a2*(ab2*
-     &               dcbet+ac2*dsbet)/wv)/am2
+     #               dcbet+ac2*dsbet)/wv)/am2
              daalp(1)=(-b*ab1-c*ac1+wv*wv*a1+2d0*ak*d1+
-     &              wv*aia*((ab1-b*a1)*dcalp+(ac1-c*a1)*dsalp))/am1
+     #              wv*aia*((ab1-b*a1)*dcalp+(ac1-c*a1)*dsalp))/am1
              daalp(2)=(a*ab1-ak*b1+wv*daba*a1*dcalp)/am1
              daalp(3)=(a*ac1-ak*c1+wv*daba*a1*dsalp)/am1
              daalp(4)=(2d0*ak*a1)/am1
              dabet(1)=(-b*ab2-c*ac2+wv*wv*a2+2d0*ak*d2+
-     &             wv*aia*((ab2-b*a2)*dcbet+(ac2-c*a2)*dsbet))/am2
+     #             wv*aia*((ab2-b*a2)*dcbet+(ac2-c*a2)*dsbet))/am2
              dabet(2)=(a*ab2-ak*b2+wv*daba*a2*dcbet)/am2
              dabet(3)=(a*ac2-ak*c2+wv*daba*a2*dsbet)/am2
              dabet(4)=(2d0*ak*a2)/am2
-               dv(2)=R42*b*vv1
-               dv(3)=R42*c*vv1
-               dv(4)=(d-R42*a)*vv1
-               dv(1)=-dv(4)*R42
-               dx(1)=R42*vv1-(d+R42*a)*dv(1)*vv2
-             dx(2)=-(d+R42*a)*dv(2)*vv2
-             dx(3)=-(d+R42*a)*dv(3)*vv2
-             dx(4)=1d0*vv1-(d+R42*a)*dv(4)*vv2
+               dv(2)=R42*b*vv1      
+               dv(3)=R42*c*vv1      
+               dv(4)=(d-R42*a)*vv1      
+               dv(1)=-dv(4)*R42      
+               dx(1)=R42*vv1-(d+R42*a)*dv(1)*vv2      
+             dx(2)=-(d+R42*a)*dv(2)*vv2      
+             dx(3)=-(d+R42*a)*dv(3)*vv2      
+             dx(4)=1d0*vv1-(d+R42*a)*dv(4)*vv2      
              dy(1)=(-2d0*d+4d0*R42*a)/daba*vv1-(b*b+c*c-2d0*a*d+2d0*
-     &             R42*ak)*(aia*vv+daba*dv(1))/ak*vv2
+     #             R42*ak)*(aia*vv+daba*dv(1))/ak*vv2
                dy(2)=2d0*b/daba*vv1-(b*b+c*c-2d0*a*d+2d0*
-     &             R42*ak)*aia*dv(2)/a*vv2
+     #             R42*ak)*aia*dv(2)/a*vv2
                dy(3)=2d0*c/daba*vv1-(b*b+c*c-2d0*a*d+2d0*
-     &             R42*ak)*aia*dv(3)/a*vv2
+     #             R42*ak)*aia*dv(3)/a*vv2
                dy(4)=-2.d0*a/daba*vv1-(b*b+c*c-2.d0*a*d+2.d0*
-     &             R42*ak)*aia*dv(4)/a*vv2
+     #             R42*ak)*aia*dv(4)/a*vv2      
              dz(1)=-2d0*d/wv/a*vv1-wv*(vv+a*dv(1))/ak*vv2
              dz(2)=b/wv/a*vv1-wv*dv(2)/a*vv2
@@ -776,37 +746,37 @@
              dz(4)=-2d0/wv*vv1-wv*dv(4)/a*vv2
              dt(1)=dcotbma*dy(1)-5d-1*yv*
-     &               (dbet(1)-dalp(1))/dsbetmalp**2-((b*dcbetpalp+
-     &             c*dsbetpalp)/dsbetmalp)*dz(1)-
-     &             5d-1*zv*(((-b*dsbetpalp+c*dcbetpalp)*dsbetmalp)*
-     &             (dalp(1)+dbet(1))-((b*dcbetpalp+c*dsbetpalp)*
-     &             dcbetmalp)*(dbet(1)-dalp(1)))/dsbetmalp**2
+     1               (dbet(1)-dalp(1))/dsbetmalp**2-((b*dcbetpalp+
+     2             c*dsbetpalp)/dsbetmalp)*dz(1)-
+     3             5d-1*zv*(((-b*dsbetpalp+c*dcbetpalp)*dsbetmalp)*
+     4             (dalp(1)+dbet(1))-((b*dcbetpalp+c*dsbetpalp)*
+     5             dcbetmalp)*(dbet(1)-dalp(1)))/dsbetmalp**2
              dt(2)=dcotbma*dy(2)-5d-1*yv*
-     &             (dbet(2)-dalp(2))/dsbetmalp**2-(b*dcbetpalp+
-     &             c*dsbetpalp)/dsbetmalp*dz(2)-
-     &             5d-1*zv*((-b*dsbetpalp+c*dcbetpalp)*dsbetmalp*
-     &             (dalp(2)+dbet(2))-(b*dcbetpalp+c*dsbetpalp)*
-     &             dcbetmalp*(dbet(2)-dalp(2))+dcbetpalp
-     &             *2d0*dsbetmalp)/dsbetmalp**2
+     1             (dbet(2)-dalp(2))/dsbetmalp**2-(b*dcbetpalp+
+     2             c*dsbetpalp)/dsbetmalp*dz(2)-
+     3             5d-1*zv*((-b*dsbetpalp+c*dcbetpalp)*dsbetmalp*
+     4             (dalp(2)+dbet(2))-(b*dcbetpalp+c*dsbetpalp)*
+     5             dcbetmalp*(dbet(2)-dalp(2))+dcbetpalp
+     6             *2d0*dsbetmalp)/dsbetmalp**2
              dt(3)=dcotbma*dy(3)-5d-1*yv*
-     &             (dbet(3)-dalp(3))/dsbetmalp**2-(b*dcbetpalp+
-     &             c*dsbetpalp)/dsbetmalp*dz(3)-
-     &             5d-1*zv*((-b*dsbetpalp+c*dcbetpalp)*dsbetmalp*
-     &             (dalp(3)+dbet(3))-(b*dcbetpalp+c*dsbetpalp)*
-     &             dcbetmalp*(dbet(3)-dalp(3))+dsbetpalp*2d0*
-     &             dsbetmalp)/dsbetmalp**2
+     1             (dbet(3)-dalp(3))/dsbetmalp**2-(b*dcbetpalp+
+     2             c*dsbetpalp)/dsbetmalp*dz(3)-
+     3             5d-1*zv*((-b*dsbetpalp+c*dcbetpalp)*dsbetmalp*
+     4             (dalp(3)+dbet(3))-(b*dcbetpalp+c*dsbetpalp)*
+     5             dcbetmalp*(dbet(3)-dalp(3))+dsbetpalp*2d0*
+     6             dsbetmalp)/dsbetmalp**2
              dt(4)=dcotbma*dy(4)-5d-1*yv*
-     &             (dbet(4)-dalp(4))/dsbetmalp**2-(b*dcbetpalp+
-     &             c*dsbetpalp)/dsbetmalp*dz(4)-
-     &             5d-1*zv*((-b*dsbetpalp+c*dcbetpalp)*dsbetmalp*
-     &             (dalp(4)+dbet(4))-(b*dcbetpalp+c*dsbetpalp)*
-     &             dcbetmalp*(dbet(4)-dalp(4)))/dsbetmalp**2
+     1             (dbet(4)-dalp(4))/dsbetmalp**2-(b*dcbetpalp+
+     2             c*dsbetpalp)/dsbetmalp*dz(4)-
+     3             5d-1*zv*((-b*dsbetpalp+c*dcbetpalp)*dsbetmalp*
+     4             (dalp(4)+dbet(4))-(b*dcbetpalp+c*dsbetpalp)*
+     5             dcbetmalp*(dbet(4)-dalp(4)))/dsbetmalp**2
              di(1)=R2*(aia*(dalp(1)-dbet(1))+(pi-2d0*datan(5d-1*tt))*
-     &               dx(1)-4d0*xv*dt(1)/(4d0+tt**2))
+     #               dx(1)-4d0*xv*dt(1)/(4d0+tt**2))
              di(2)=R2*(aia*(dalp(2)-dbet(2))+(pi-2d0*datan(5d-1*tt))*
-     &               dx(2)-4d0*xv*dt(2)/(4d0+tt**2))
+     #               dx(2)-4d0*xv*dt(2)/(4d0+tt**2))
              di(3)=R2*(aia*(dalp(3)-dbet(3))+(pi-2d0*datan(5d-1*tt))*
-     &               dx(3)-4d0*xv*dt(3)/(4d0+tt**2))
+     #               dx(3)-4d0*xv*dt(3)/(4d0+tt**2))
              di(4)=R2*(aia*(dalp(4)-dbet(4))+(pi-2d0*datan(5d-1*tt))*
-     &               dx(4)-4d0*xv*dt(4)/(4d0+tt**2))
+     #               dx(4)-4d0*xv*dt(4)/(4d0+tt**2))
              dii(1,1)=2d0*ddat(jk,2)
              dii(1,2)=2d0*ddat(jk,3)
